CON


  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000

' audio pins
  _leftChannelVolume = 32
  _rightChannelVolume = 32
  _leftChannelAudioPin = 21 ' -1 ifnot installed.
  _rightChannelAudioPin = 23 ' -1 ifnot installed.
   
OBJ

  str:           "ASCII0_STREngine.spin"                 ' thanks to Kye - string routines
'  term:          "FullDuplexSerial.spin"                ' Thanks to Chip   - for debugging if display not working
  synth :        "tinysynth"                             ' Thanks Ahle2 http://forums.parallax.com/showthread.php?139724-TinySynth-!
  wavplayer:     "WavPlayer"                             ' Kye's wav player object
  tch:           "Touch"                                 ' touchscreen driver 
VAR
   byte LineOfText1[20]         ' general purpose string buffer
   byte LineOfText2[20]         ' general purpose string buffer
                  
   long DecRate                 ' synth settings
   long SusLevel
   long PWinit
   long pwmRate
   long Filter
   long Portamento
   
PUB Main | touchtest  ' debug value
  tch.Begin
  Touchscreen                                           ' wait for input

PUB TouchScreen  | yval, xval,pointer
    repeat
      yval := tch.TouchYPercent                           ' decode yval 0-100%               
      xval := tch.TouchXPercent                          ' decode xval 0-100%
      if (xval <> 255)  and (yval <> 255)
        'tch.SelectMemGroup
        'hex(xval,2)      ' if display any debug messages need to restart the SPI cog as it has been stopped by the debug display
        'hex(yval,2)
        'repeat
        pointer := (yval/20)*4+(xval/25)       ' so can use a case statement 0-19
        if pointer < 20
          tch.SelectMemGroup
        case pointer                                    ' 0 to 19
           0:                   
           1:                   
           2:
           3:
           4:
           5: 
           6:
           7:
           8:  PhotoAlbum
           9:  Calculator                 
           10: LoremPortLand
           11: result := tch.Chain(string("MOVIE.EXE"))              'chain this precompiled program
           12: Keyboard
           13: Music
           14: WavPlayer.WavDemo
           15: Buttons
           16: PlaySynthesizer
           17: HTML
           18: 
           19: 

        tch.SetOrientation(true)
        tch.SelectMemGroup                              ' ready for mem out
        tch.DrawDesktop                                 ' redraw the background
        tch.SelectSPIGroup                              ' restart the spi driver

PUB Music | f                                               ' use Lassus font, and use font smoothing and supersampling. 60 points works. Modify chr 45 manually (bar line) as width is 6 but advance is 5
     tch.SetCursor(0,0)                                 ' sets curx to  zero and cury to zero
     tch.SetOrientation(false)                          ' http://www.dafont.com/lassus.font
     tch.RamErase(1)                                    ' erase all but file 0 (desktop)
     tch.Clearscreen(tch.RGBtoWord(255,255,255))        ' white background for music
     f := tch.Loadfont(string("Lass60.ifn"))   'load font into file 1
     tch.TextT(f,string("`",203,"+++8-****-FF/="))      ' line of treble clef music
     tch.crlf
     tch.TextT(f,string("1",164,"cb-0v-HJKLSSSS-i="))   ' line of bass clef music    
     repeat                                             ' end program

PUB HTML | f,f2 ' based on http://www.w3schools.com/html/html_iframe.asp and the Opera browser - text boxes, check boxes, scrollbars etc. Gray for inactive, light purple for active
   tch.Clearscreen($FFFF)                             ' clear the screen to white
   tch.Ramerase(1)                                      ' erase all but file 0 (desktop)
   tch.SDBMPtoRam(string("arrupgry.bmp"))             ' file 1 up arrow part of the slider
   tch.SDBMPtoRam(string("arrdngry.bmp"))             ' file 2 down arrow part of the slider
   tch.SDBMPtoRam(string("scrolcnr.bmp"))             ' file 3 corner gray part of the slider
   tch.SDBMPtoRam(string("arrlgry.bmp"))              ' file 4 left gray
   tch.SDBMPtoRam(string("arrrgry.bmp"))              ' file 5 right gray
   tch.SDBMPtoRam(string("slivegry.bmp"))             ' file 6 slider vertical gray
   tch.SDBMPtoRam(string("slihogry.bmp"))             ' file 7 slider horizontal gray      
   iframe(10,10,120,200,50,128)                       ' x1,y1,x2,y2,slider h 0-255, slider w
   ' dropdown select box
   SelectDemo(130,10,235)                               ' dropdown select box
   repeat

   

PRI iframe(x1,y1,x2,y2,h,w)         ' see 3schools tutorial
   tch.Drawline(x1-1,y1-1,x2+1,y1-1,tch.RGBtoWord(0,0,0)) ' black line at top
   tch.Drawline(x1-2,y1-2,x2+2,y1-2,tch.RGBtoWord(0,0,0)) ' black line at top dual line
   tch.Drawline(x1-1,y1-1,x1-1,y2+1,tch.RGBtoWord(0,0,0)) ' left black line
   tch.Drawline(x1-2,y1-2,x1-2,y2+2,tch.RGBtoWord(0,0,0)) ' left double black line
   tch.Drawline(x2+1,y1,x2+1,y2+1,tch.RGBtoWord(128,128,128)) ' right gray line
   tch.Drawline(x2+2,y1-1,x2+2,y2+2,tch.RGBtoWord(128,128,128)) ' right gray line double
   tch.Drawline(x1,y2+1,x2+1,y2+1,tch.RGBtoWord(128,128,128)) ' gray line at bottom
   tch.Drawline(x1-1,y2+2,x2+2,y2+2,tch.RGBtoWord(128,128,128)) ' gray line at bottom dual line
   tch.Drawline(x2-15,y1,x2,y2,tch.RGBtoWord(240,240,240)) ' slider background vertical
   tch.Drawline(x1,y2-15,x2,y2,tch.RGBtoWord(240,240,240)) ' slider background horizontal
   tch.DrawBMPRam(1,x2-15,y1)                           ' draw file 1 up arrow
   tch.DrawBMPRam(2,x2-15,y2-31)                        ' draw file 2 down arrow
   tch.DrawBMPRam(3,x2-15,y2-15)                        ' draw file 3 corner gray
   tch.DrawBMPRam(4,x1,y2-15)                           ' draw file 4 left gray
   tch.DrawBMPRam(5,x2-31,y2-15)                        ' draw file 5 right gray
   tch.DrawBMPRam(6,x2-15,y1+16+(y2-y1-80)*h/255)       ' draw file 6 vertical slider 
   tch.DrawBMPRam(7,x1+16+(x2-x1-80)*w/255,y2-15)       ' draw file 7 horizontal slider

PRI SelectDemo(x1,y1,x2) | f,f2
   '<!DOCTYPE html>
   '<html>
   '<body>
  '<select>
  '<option>Volvo</option>
  '<option>Saab</option>
  '<option>Mercedes</option>
  '<option>Audi</option>
  '</select>
  '</body>
  '</html>
   tch.SDBMPtoRam(string("arrdn18.bmp"))              ' down arrow 16x18   
   SelectBoxStart(x1,y1,x2,tch.getfilenumber-1) 'x1,y1,x2 file number of the down arrow bitmap
   SelectBoxItems(x1,y1,x2,4) ' 4 items in this box
   f := tch.Loadfont(string("Arial16.ifn"))             ' file 9 black on white font
   tch.setcurx(x1 +3)                                 ' position of text based on location of select box
   tch.setcury(y1)                                     
   tch.TextT(f,string("File1.wav"))                     ' text
   f2 := tch.Loadfont(string("Arial16B.ifn"))           ' file 10 white on dark blue for highlighted
   tch.setcurx(x1+3)                                   ' position of text based on location of select box
   tch.setcury(y1+20)
   tch.Drawline(x1-1,y1+19,x2,y1+19+18,tch.RGBtoWord(10,36,106)) ' dark blue background for arial16b font
   tch.TextT(f2,string("File1.wav"))                     ' text
   tch.setcurx(x1+3)
   tch.setcury(tch.getcury+18)
   tch.TextT(f,string("File2.wav"))                      ' unhighlighted text
   tch.setcurx(x1+3)
   tch.setcury(tch.getcury+18)
   tch.TextT(f,string("File3.wav"))
   tch.setcurx(x1+3)
   tch.setcury(tch.getcury+18)
   tch.TextT(f,string("File4.wav"))

   

PRI SelectBoxStart(x1,y1,x2,n) ' y2 =y1+17
   tch.DrawBMPRam(n,x2-16,y1)                         ' down arrow 
   tch.Drawline(x1-2,y1-2,x2+1,y1-2,tch.RGBtoWord(178,185,195)) ' top line
   tch.Drawline(x1-1,y1-1,x2,y1-1,tch.RGBtoWord(236,236,236)) ' top lighter line
   tch.Drawline(x1-2,y1+19,x2+1,y1+19,tch.RGBtoWord(178,185,195))' bottom line
   tch.Drawline(x1-2,y1-2,x1-2,y1+19,tch.RGBtoWord(178,185,195)) ' left line
   tch.Drawline(x1-1,y1-1,x1-1,y1+18,tch.RGBtoWord(236,236,236)) ' left lighter line
   tch.Drawline(x2+1,y1-2,x2+1,y1+19,tch.RGBtoWord(178,185,195)) ' right line

PRI SelectBoxItems(x1,y1,x2,n) ' each line is 18 high. n = number of items
   tch.Drawline(x1-2,y1+20,x2+1,y1+20,0)                ' top line of a box black
   tch.Drawline(x1-2,y1+20+n*18,x2+1,y1+20+n*18,0)      ' bottom line of a box
   tch.Drawline(x1-2,y1+20,x1-2,y1+20+n*18,0)           ' left line
   tch.Drawline(x2+1,y1+20,x2+1,y1+20+n*18,0)           ' right line   

PUB Buttons | ck1x,ck1y,ck1s,ck2x,ck2y,ck2s,rd1x,rd1y,rd1s,rd2x,rd2y,rd2s,rd3x,rd3y,rd3s,bu1x,bu1y,xval,yval,redraw,f,f2,sx1,sy1,sx2,sy2 ' test out buttons, radio buttons, checkboxes 
   tch.SetOrientation(true)                             ' portrait view
   tch.Ramerase(1)                                        ' clear the ram disk 
   tch.Clearscreen(tch.RGBtoWord(212,208,200))          ' background gray color determined from paintshop
   tch.Textbox(10,200,120,215)                          ' clear a text box. height = fontheight+1?
   f := tch.Loadfont(string("MSans14W.ifn"))            ' file 1 black on white font
   tch.setcurx(12)                                      ' x = x1+2 in textboxclear and see lorem for displaying text from an sd card
   tch.setcury(201)                                     ' y = y1 in textboxclear
   tch.TextT(f,string("This is a textbox"))             ' draw text for the textbox
   f2 := tch.Loadfont(string("MSans14.ifn"))            ' file 2 black on gray 14 point seems to be the same as 8.25 in vb.net ? why
   tch.SDBMPtoRam(string("butn8430.bmp"))               ' file 3 a button 84x30 in size
   tch.SDBMPtoRam(string("Uncheckd.bmp"))               ' file 4 unchecked checkbox pic3
   tch.SDBMPtoRam(string("Checked.bmp"))                ' file 5 checked checkbox pic4
   tch.SDBMPtoRam(string("RadioUnc.bmp"))               ' file 6 unchecked radiobox pic 5
   tch.SDBMPtoRam(string("RadioChk.bmp"))               ' file 7 checked radiobox pic 6
   tch.SDBMPtoRam(string("hot120.bmp"))                 ' file 8 picturebox demo
   tch.DrawBMPRam(8,115,10)                             ' draw file 8
   redraw := true    
   ' set all the locations of the objects on the screen
   sx1:=130                                            ' select box (similar to a multiline text box)
   sy1:=160
   sx2:=230
   sy2:=260
   tch.Selectbox(sx1,sy1,sx2,sy2)                       ' draw a multiline selectbox
   tch.MoveVerticalScroll(sx2,sy1,sy2,0)                   ' scrollbar to item 0 (0-255)
   ck1x := ck2x := rd1x := rd2x := rd3x := 20           ' x all the same 
   ck1y := 10    
   ck2y := ck1y + 40                                    ' y coordinates
   rd1y := ck2y + 40
   rd2y := rd1y + 40
   rd3y := rd2y + 40
   bu1x := 80                                           ' button position
   bu1y := 280
   ck1s := true                                         ' startup status
   ck2s := false
   rd1s := true
   rd2s := false
   rd3s := false
   ' now wait for touch
   tch.SelectSPIGroup                                   ' talk to the spi touchscreen
   repeat
      if redraw                                         ' if redraw true then redraw all the objects
         tch.SelectMemGroup                             ' display mode
         tch.DrawCheckbox(ck1x,ck1y,ck1s,string("Check1"),4,5,f2)        ' checkbox
         tch.DrawCheckbox(ck2x,ck2y,ck2s,string("Check2"),4,5,f2)        ' checkbox
         tch.DrawRadiobox(rd1x,rd1y,rd1s,string("Radiobutton1"),6,7,f2)     ' radiobox
         tch.DrawRadiobox(rd2x,rd2y,rd2s,string("Radiobutton1"),6,7,f2)     ' radiobox 
         tch.DrawRadiobox(rd3x,rd3y,rd3s,string("Radiobutton2"),6,7,f2)     ' radiobox
         tch.DrawButton(bu1x,bu1y,string("Ok"),3,f2)              ' button (fixed size at the moment)
         redraw := false
         tch.SelectSPIGroup                             ' talk to the spi touchscreen  
      yval := tch.TouchYPercent                         ' decode yval 0-100%                
      xval := tch.TouchXPercent                         ' decode xval 0-100%
      if (xval <> 255)  and (yval <> 255)               ' valid keypress
        xval := (xval * 24) / 10                        ' scale to pixels as can measure from the picture in paintshop
        yval := (yval * 32) / 10                        ' scale to pixels
        if xval < 100
          case yval
            (ck1y-10)..(ck1y+25): !ck1s                   ' checkbox is small so active area bigger than the checkbox
                                  redraw := true          ' redraw the screen
            (ck2y-10)..(ck2y+25): !ck2s                   ' checkbox is small so active area bigger than the checkbox
                                  redraw := true         
            (rd1y-10)..(rd1y+25): rd1s :=   true            ' there probably is a smarter way to make one value true and all the rest false
                                  rd2s :=   false
                                  rd3s :=   false                   
                                  redraw := true
            (rd2y-10)..(rd2y+25): rd1s :=   false            
                                  rd2s :=   true
                                  rd3s :=   false                   
                                  redraw := true
            (rd3y-10)..(rd3y+25): rd1s :=   false            
                                  rd2s :=   false
                                  rd3s :=   true                  
                                  redraw := true
          tch.pause1ms(250)                               ' debounce 
                                     
        case yval
          bu1y..(bu1y + 30): return                     ' button so exit this screen

        if (xval > sx2 - 25) and (xval < sx2+10) and (yval > sy1) and (yval < sy2) ' slider knob
           tch.SelectMemGroup                             ' display mode
           tch.MoveVerticalScroll(sx2,sy1,sy2,yval)      ' there is some maths based on sy1, sy2 and yval to work out a percentage  
           tch.SelectSPIGroup                             ' talk to the spi touchscreen    

PUB Keyboard | capslock, backspace,xval,yval,address,ascii,f
   tch.Clearscreen(%00000000_00000000)                  ' clear the screen
   tch.SetOrientation(false)                            ' landscape view
   tch.Ramerase(1)                                        ' clear the ram disk  
   f := tch.Loadfont(string("Arial30.ifn"))             ' font = file 1
   tch.DrawBMPRam(tch.SDBMPtoRam(string("KeyL.bmp")),0,0) ' load and draw in one command
   capslock := 0 ' default to off                       ' caps lock 
   backspace := 0 'default to off                       ' backspace is zero
   str.builtstring(true)                                ' clear the working string
   tch.SelectSPIGroup                                   ' talk to the spi touchscreen
   tch.SetCursor(4,27)                                  ' cursor to top left with the margin
   repeat
      xval := tch.TouchYPercent                       ' decode yval 0-100%  and swap x and y as this is landscape mode              
      yval := tch.TouchXPercent                      ' decode xval 0-100%
      if (xval <> 255)  and (yval <> 255)               ' valid keypress
        tch.SelectMemGroup                              ' displaying now
        address :=255
        ascii := 255
        xval := (xval * 32) / 10                        ' scale to pixels as can measure from the picture in paintshop
        yval := 240 - ((yval * 24) / 10)                ' scale to pixels and org top left                        
        case yval
          133..162:address := xval / 32                 ' top row qwertyuiop
          163..188:address := 10 + ((xval-17) / 32)     ' second row addres 10 up, offset
          189..214:address := 19 + ((xval -47) / 32)    ' third row, includes two buttons in one
                   if xval<47
                     address := 255                     ' non printing character capslock
                     !capslock                          ' toggle capslock
                   if xval >273
                     !backspace                         ' backspace character
          215..239:if xval >64 and xval < 256
                      address := 26                     ' space bar 
                   if xval>256
                      address :=27                      ' carriage return (LF added below)   
        if address < 255 and backspace == 0
           ascii := lookupz(address: "Q","W","E","R","T","Y","U","I","O","P","A","S","D","F","G","H","J","K","L","Z","X","C","V","B","N","M",32,13)
          if (capslock == 0) and (ascii => 65) and (ascii =< 90) 
            ascii += 32                                 ' lower case              
          tch.setcurx(tch.TextChar(f,ascii,tch.getcurx,tch.getcury)) ' only print if a valid ascii character
          str.buildstring(ascii)
          if ascii == 13                                ' add line feed if this is a return
            ascii := 10                                 ' add LF
            tch.setcurx(tch.TextChar(f,ascii,tch.getcurx,tch.getcury)) ' display line feed
            str.buildstring(ascii)                      ' and add to the built string
        if backspace <>0                                ' backspace redraws the entire string buffer
          backspace := 0                                ' backspace now zero
          str.buildstring(8)                            ' kye's string routine removes a character
          tch.ClearRectangle(0,22,319,132,tch.GetBackFontColor) ' clear an area the same color as the font background
          tch.SetCursor(4,27)                           ' top left of the screen with the margin
          tch.TextT(f,str.builtstring(false))    ' redraw text
        
        if xval => 0 and xval <45 and yval => 0 and yval <21
          return                                        ' cancel button
        if xval => 280 and xval < 320 and yval => 0 and yval <21
          result := str.builtstring(true)                   ' the 'send' button returns the string including carriage return, line feeds (can do multiple lines of input)
          return
        tch.pause1ms(250)                               ' debounce
        tch.SelectSPIGroup                              ' wait for next keypress



PUB PhotoAlbum | picturenumber
   tch.Clearscreen(%00000000_00000000)                  ' clear the screen
   tch.SetCursor(0,0)
   tch.Text(string("Please wait 8s"))
   tch.Ramerase(1)                                        ' erase all but file 0 (desktop)
   'tch.SDBMPtoRam(string("cat.bmp"))                    ' file 1
   'tch.SDBMPtoRam(string("wallaby.bmp"))                ' file 2
   'tch.SDBMPtoRam(string("kluger.bmp"))                 ' file 3
   'tch.SDBMPtoRam(string("elle.bmp"))                   ' file 4
   'tch.SDBMPtoRam(string("balln.bmp"))                  ' file 5
   tch.SDBMPtoRam(string("slide1.bmp"))                    ' file 1
   tch.SDBMPtoRam(string("slide2.bmp"))                ' file 2
   tch.SDBMPtoRam(string("slide3.bmp"))                 ' file 3
   tch.SDBMPtoRam(string("slide4.bmp"))                   ' file 4
   tch.SDBMPtoRam(string("slide5.bmp"))                  ' file 5
   picturenumber := 1
   repeat until picturenumber > 5
     'if picturenumber ==2
     '   tch.SetOrientation(false)                       ' draw a landscape picture
     '   tch.DrawBMPRam(2,0,0)                             ' draw picture 2 
     '   tch.SetOrientation(true)
     'else
        tch.DrawBMPRam(Picturenumber,0,0)               ' draw the picture
     result := tch.TouchSwishY                          ' swish left to right or up to down depending on orientation
     if result > 0
       picturenumber --
     else
       picturenumber ++
   tch.Clearscreen(%00000000_00000000)
   tch.pause1ms(1000) ' otherwise still touching the screen
      


    
PUB PlaySynthesizer | xval,yval,portsw,note ' see next routine for automatic tunes
    synth.start(21, 23)                                 ' start the synth
    portsw := false                                     ' portamento off
    PWinit := 255                                        ' synth settings all 0-255
    pwmRate := 12
    decRate := 200                                      
    susLevel := 255
    filter := 16
    portamento := 6  
    tch.Clearscreen(%00000000_00000000)                 ' 
    tch.Ramerase(1)                                       ' erase all but file 0 (desktop)
    tch.SDBMPtoRam(string("synth2.bmp"))                ' file 1
    tch.SDBMPtoRam(string("synoff.bmp"))              ' file 2
    tch.SDBMPtoRam(string("synon.bmp"))               ' file 3
    tch.SDBMPtoRam(string("synknb.bmp"))              ' file 4
    tch.SDBMPtoRam(string("synslbk.bmp"))             ' file 5
    tch.DrawBMPRam(1,0,0)                               ' draw the picture
    tch.DrawBMPRam(2,148,241)                           ' draw file 2
    tch.DrawBMPRam(3,148,283)                           ' draw file 3
    RefreshSliders                                      ' draw all the sliders                              
    tch.SelectSPIGroup                                    ' talk to the spi touchscreen
    repeat
      yval := tch.TouchYPercent                           ' decode yval 0-100%               
      xval := tch.TouchXPercent                           ' decode xval 0-100%
      if (xval <> 255)  and (yval <> 255)                    ' valid keypress
         xval := (xval*24)/10                             ' 0-240, use portrait mode but it doesn't matter  
         yval := (yval*32)/10
         if xval>143 and xval <199 and yval >280 and yval <320
           synth.stop                                     ' close down the synthesizer
           return
         if xval >143 and xval <199 and yval > 240 and yval < 275 ' portamento switch
           tch.SelectMemGroup
           !portsw                                      ' change status
           if portsw
                 tch.DrawBMPRam(3,148,241)              ' switch on 
                 synth.noteOn(30, 19, 60, 12, 3, 6)                             ' turn on a note, next notes slide to this 
           else      
                 tch.DrawBMPRam(2,148,241)              ' switch off
                 synth.noteOff(18)                                              ' turn off any portamento
           tch.pause1ms(250) ' debounce delay  
           tch.SelectSPIGroup
         if xval >132 and xval <202 and yval >9 and yval <244                   ' one of the 5 sliders
           case yval
             9..9+34:   DecRate := ReadSlider(xval,1)                             ' move the slider and scale value
             53..53+34: SusLevel := ReadSlider(xval,2)     
             88..88+34: PWinit := ReadSlider(xval,3)
             124..124+34:PWMRate := ReadSlider(xval,4)
             162..162+34:Filter := ReadSlider(xval,5)
             210..210+34:Portamento := ReadSlider(xval,6)
         if xval < 53                                                           ' white keys     
          case yval                                     
             0..23 : note := 20                              
             24..56 : note := 22
             57..89: note := 24
             90..119 : note := 25
             120..148: note := 27  
             149..177: note := 29  
             178..207: note := 31  
             208..238: note := 32  
             239..266: note := 34  
             267..297: note := 36  
             298..320: note := 37
         if (xval > 54) and (xval < 118)                     ' black keys a little bit wider so can play them
           case yval
             10..44: note := 21  
             47..77: note := 23
             102..131: note := 26  
             133..162: note := 28  
             166..193: note := 30  
             221..250: note := 33  
             255..284: note := 35
         if note <> 0                                                           ' play note
           if portsw                                              ' portamento switch
              synth.slideToNote(note, portamento/16) 
           else
             synth.pluck(note, decRate/12, susLevel/4, pwinit, pwmRate/6, filter/32)        ' do any scaling here, all values 0-255
           note := 0

PUB SynthSlider(x,y,value)                              ' value is 0-255. assumes bitmaps in ram
    tch.DrawBMPRam(5,x,y)                               ' draw background
    tch.DrawBMPRam(4,x+((value*100)/450),y+5)           ' draw the knob

PUB RefreshSliders | n
    repeat n from 1 to 6
      RedrawOneSlider(n)

PUB ReadSlider(y,n)
    y := y - 132                                            ' origin of the slider is 132
    y := y*256                                              ' slider is 69 pixels so convert to 256   
    y := y / 69
    if y < 0                                                ' check bounds
      y := 0
    if y > 255
      y := 255
    tch.SelectMemGroup
    RedrawOneSlider(n)                                  ' redraw this slider
    tch.SelectSPIGroup 
    result := y                    

PUB RedrawOneSlider(n)                                  ' n = 1,2,3,4,5,6
   case n
     1:SynthSlider(132,9,decRate)                           ' decay     
     2:SynthSlider(132,53,susLevel)                         ' sustain
     3:SynthSlider(132,88,pwinit)                           ' pwminit
     4:SynthSlider(132,124,pwmRate)                         ' pwmrate
     5:SynthSlider(132,162,filter)                          ' filter (0-12 so multiply by 21)
     6:SynthSlider(132,210,portamento)                       ' portamento 0 - 16
     
' ********************************** end synth routines ************************


PUB Calculator | xval,yval,address,ascii,operand,f
    tch.Clearscreen(%00000000_00000000)                 ' so something happens immediately
    tch.Ramerase(1)                                       ' erase all but file 0 (desktop)
    tch.SDBMPtoRam(string("calcpic.bmp"))                ' file 1
    tch.DrawBMPRam(1,0,0)                               ' draw the picture    
    f := tch.Loadfont(string("DSdig.ifn"))              ' file 2 in the ram disk, use this number when printing fonts
    str.builtstring(true)                               ' clear the working string
    tch.SelectSPIGroup                                  ' talk to the spi touchscreen
    repeat
      yval := tch.TouchYPercent                           ' decode yval 0-100%               
      xval := tch.TouchXPercent                           ' decode xval 0-100%
      if (xval <> 255)  and (yval <> 255)                    ' valid keypress
        address :=0
        case (yval*32)/10                                    ' convert 0-100 to 0-320 as easier to work with pixels off the picture
          60..101: address :=0                               ' row of a 4x6 matrix
          104..140: address :=4
          146..183: address :=8
          187..222: address :=12
          228..265: address :=16
          271..307: address :=20
        case (xval*24)/10                                   ' column convert percent to 0-239
          0..66: address += 0
          67..119: address +=1
          120..172: address +=2
          173..239: address +=3
        ascii := lookupz(address: "X","Q","Q","Q","C",8,"/","*","7","8","9","-","4","5","6","+","1","2","3","=","0","0",".","=")
        case ascii
          "X"             : return                                              ' close the calculator
          "C"             : str.builtstring(true)                               ' clear the current string
                            CalcClear
          "0".."9",8      : str.buildstring(ascii)                              ' build the string. Can also handle backspace
                            CalcClear                            
                            tch.TextT(f,str.builtstring(false))          ' reprint the string each new char in case a backspace 
          "+","-","*","/" : str.buildstring(ascii) ' display these too so can see typed something
                            CalcClear
                            tch.TextT(f,str.builtstring(false))
                            str.copy(str.builtstring(true),@lineoftext1)        ' move the string to lineoftext1 and reset
                            operand := ascii
          "=" :             xval := str.decimaltointeger(@lineoftext1)          ' first operand. recycle xval and yval
                            yval := str.decimaltointeger(str.builtstring(true)) ' second operand
                            case operand
                                  "+" : address := xval + yval                  ' add
                                  "-" : address := xval - yval                  ' subtract
                                  "*" : address := xval * yval                  ' multiply
                                  "/" : address := xval / yval                  ' integer division
                            str.str(@lineoftext2,address)                       ' convert answer to string
                            str.trimstring(@lineoftext2) ' if negative, leave the -, if positive remove the leading space
                            CalcClear                                           ' clear the display ready to print the answer
                            tch.TextT(f,@lineoftext2)                           ' print the answer
        tch.SelectSPIGroup                                                      ' restart the spi group if display something
        tch.pause1ms(250)' only display once so delay half a second to "debounce"

PUB CalcClear
     tch.ClearRectangle(25,21,220,48,tch.GetBackFontColor) ' clear an area the same color as the font background   
     tch.SetCursor(25,15)
  

PUB LoremPortLand
    tch.SetOrientation(false)
    Lorem
    tch.SetOrientation(true)
    Lorem


PUB Lorem | pointer,c,block,f,b
     tch.Ramerase(1)
     tch.SDtoRam(string("Lorem2.txt"))                  ' file 1, Ramsize[1] is in words, not bytes                                 
     tch.SetCursor(0,0)                                 ' sets curx to  zero and cury to zero
     f := tch.Loadfont(string("Times20.ifn"))                'load font , file 2
     tch.Clearscreen($FFFF)                           ' clear the screen to white
     tch.setcurx(4)                                     ' some letters have an xoffset of -1 and so won't display
     b := tch.FetchRamBuffer                            ' location of the text
     repeat block from 0 to 0                           ' block is 128 words = 256 bytes
       tch.RamToHub(tch.GetRamlocation(1)+(block<<7),256)      ' read text into rambuffer at the ram location file 1
       pointer :=0
       repeat 256
          c := byte[b][pointer]  
         if c=< 126
           tch.setcurx(tch.TextChar(f,c,tch.getcurx,tch.getcury))  ' only print if a valid ascii character
         pointer ++
     tch.pause1ms(2000)

